<template>
  <div class="component-upload-image">
    <el-tooltip class="item" effect="dark" :content="'请上传' +fileType.join('/')+'格式的文件'  " placement="top-start">
    <el-upload
      multiple
      :action="uploadImgUrl"
      list-type="picture-card"
      :on-success="handleUploadSuccess"
      :before-upload="handleBeforeUpload"
      :limit="limit"
      :typeg="typeg"
      :on-error="handleUploadError"
      :on-exceed="handleExceed"
      ref="imageUpload"
      :on-remove="handleDelete"

      :headers="headers"
      :file-list="fileList"
      :on-preview="handlePictureCardPreview"
      :class="{hide: this.fileList.length >= this.limit}"
    >
      <i class="el-icon-camera"></i>
    </el-upload>
    </el-tooltip>

    <!-- 上传提示 -->
    <!-- <div class="el-upload__tip" slot="tip" v-if="showTip">
      请上传
      <template v-if="fileSize"> 大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b> </template>
      <template v-if="fileType"> 格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b> </template>
      的文件
    </div> -->

    <el-dialog
      :visible.sync="dialogVisible"
      title="预览"
      width="800"
      append-to-body
    >
      <img
        :src="dialogImageUrl"
        style="display: block; max-width: 100%; margin: 0 auto"
      />
    </el-dialog>
  </div>
</template>

<script>
import { getToken } from "@/utils/auth";
import { isExternal } from "@/utils/validate";
import { ocrIdCard,licensePlate,realEstateCertificate} from "@/api/wuguan/landlord";

export default {
  props: {
    value: [String, Object, Array],
    // 图片数量限制
    limit: {
      type: Number,
      default: 5,
    },
    // 大小限制(MB)
    fileSize: {
       type: Number,
      default: 900,
    },
    // 识别类型  1 身份证  2 车牌  3 违停 4房产证
    typeg: {
       type: Number,
      default: 5,
    },

    // 文件类型, 例如['png', 'jpg', 'jpeg']
    fileType: {
      type: Array,
      default: () => ["png", "jpg", "jpeg"],
    },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      number: 0,
      uploadList: [],
      dialogImageUrl: "",
      dialogVisible: false,
      hideUpload: false,
      baseUrl: process.env.VUE_APP_BASE_API,
      uploadImgUrl: process.env.VUE_APP_BASE_API + "/common/upload", // 上传的图片服务器地址
      headers: {
        Authorization: "Bearer " + getToken(),
      },
      fileList: [],
      isgse:false
    };
  },
  watch: {
    value: {
      handler(val) {
        if (val) {
          // 首先将值转为数组
          const list = Array.isArray(val) ? val : this.value.split(',');
          // 然后将数组转为对象数组
          this.fileList = list.map(item => {
            if (typeof item === "string") {
              if (item.indexOf(this.baseUrl) === -1 && !isExternal(item)) {
                  item = { name: this.baseUrl + item, url: this.baseUrl + item };
              } else {
                  item = { name: item, url: item };
              }
            }
            return item;
          });
        } else {
          this.fileList = [];
          return [];
        }
      },
      deep: true,
      immediate: true
    }
  },
  computed: {
    // 是否显示提示
    showTip() {
      return this.isShowTip && (this.fileType || this.fileSize);
    },

  },
  created() {
    console.log(this.fileList)
  },
  methods: {
    // 上传前loading加载
    handleBeforeUpload(file) {
      console.log(this.typeg,4,this.fileList,this.limit)
      let isImg = false;
      if (this.fileType.length) {
        let fileExtension = "";
        if (file.name.lastIndexOf(".") > -1) {
          fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
        }
        isImg = this.fileType.some(type => {
          if (file.type.indexOf(type) > -1) return true;
          if (fileExtension && fileExtension.indexOf(type) > -1) return true;
          return false;
        });
      } else {
        isImg = file.type.indexOf("image") > -1;
      }

      if (!isImg) {
        this.$modal.msgError(`文件格式不正确，请上传${this.fileType.join("/")}图片格式文件!`);
        return false;
      }
      if (file.name.includes(',')) {
        this.$modal.msgError('文件名不正确，不能包含英文逗号!');
        return false;
      }
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize;
        if (!isLt) {
          this.$modal.msgError(`上传头像图片大小不能超过 ${this.fileSize} MB!`);
          return false;
        }
      }
      this.$modal.loading("正在上传图片，请稍候...");
      this.number++;
    },
    // 文件个数超出
    handleExceed(files, fileList) {
       // console.log(this.fileList,files, fileList,5,this.limit)
       if(this.fileList.length !=0){
         this.$modal.msgError(`上传文件数量不能超过 ${this.limit} 个!`);
       }else{
         this.clearFiles()
         // return
       }

    },
    // 清楚已经上传的文件
    clearFiles () {
          this.$refs['imageUpload'].clearFiles();
      },

    // 上传成功回调
    handleUploadSuccess(res, file) {
      if (res.code === 200) {
        this.$modal.closeLoading();
        this.isgse = false
        // this.fileList= []
        if(this.typeg == 1){
          let nget={'idCardSide':'front','image':res.urlOnline}
          ocrIdCard(nget).then(response => {
           this.uploadList.push({ name: res.fileName, url: res.fileName });
           this.isgse = true
           this.uploadList.filter(rou=>{
             rou.address =  response.data.address
             rou.idCard= response.data.idCard
             // idCard:342224199212121234,
             rou.realName=  response.data.realName

           })
             this.uploadedSuccessfully();
          });
        }else if(this.typeg == 2){
          let nget={'image':res.urlOnline}
          // 车牌号
          licensePlate(nget).then(response => {
           this.uploadList.push({ name: res.fileName, url: res.fileName });
           console.log(this.uploadList)
           this.isgse = true
           this.uploadList.filter(rou=>{
             rou.plateNumber =  response.msg
           })

             this.uploadedSuccessfully();

          });
        }else if(this.typeg == 4){
          // 房产证
          let nget={'image':res.urlOnline}
          // 车牌号
          realEstateCertificate(nget).then(response => {
           this.uploadList.push({ name: res.fileName, url: res.fileName });
           this.isgse = true
           this.uploadList.filter(row=>{
             row.area = response.data.area
             row.coOwner = response.data.coOwner
             row.coOwnership = response.data.coOwnership
             row.documentNumber = response.data.documentNumber
             row.location = response.data.location
             row.ownerName = response.data.ownerName
             row.propertyUnitNumber = response.data.propertyUnitNumber
             row.registrationDate = response.data.registrationDate
             row.rightType = response.data.rightType
             row.usagePeriod = response.data.usagePeriod
             row.usageType = response.data.usageType

             // rou.plateNumber =  response.msg
           })
             this.uploadedSuccessfully();
          });
        }
       if(this.isgse == false){
         this.clearFiles()
         this.number = 1
       }

        // this.uploadedSuccessfully();
      } else {
        this.number--;
        this.$modal.closeLoading();
        this.$modal.msgError(res.msg);
        this.$refs.imageUpload.handleRemove(file);
        this.uploadedSuccessfully();
      }
    },
    // 删除图片
    handleDelete(file) {
      const findex = this.fileList.map(f => f.name).indexOf(file.name);
      if (findex > -1) {
        this.fileList.splice(findex, 1);
        this.$emit("input", this.listToString(this.fileList));
      }
    },
    // 上传失败
    handleUploadError() {
      this.$modal.msgError("上传图片失败，请重试");
      this.$modal.closeLoading();
    },
    // 上传结束处理
    uploadedSuccessfully() {
      console.log(2,this.uploadList,this.number)
      if (this.number > 0 && this.uploadList.length === this.number) {
        console.log(this.uploadList)
        this.fileList = this.fileList.concat(this.uploadList);
        this.uploadList = [];
        this.number = 0;
        console.log(this.fileList)
        this.$emit("input", this.listToString(this.fileList));
        this.$emit("uploadedSuccessfully", this.fileList);
        this.$modal.closeLoading();
      }
    },
    // 预览
    handlePictureCardPreview(file) {
      this.dialogImageUrl = file.url;
      this.dialogVisible = true;
    },
    // 对象转成指定字符串分隔
    listToString(list, separator) {
      let strs = "";
      separator = separator || ",";
      for (let i in list) {
        if (list[i].url) {
          strs += list[i].url.replace(this.baseUrl, "") + separator;
        }
      }
      return strs != '' ? strs.substr(0, strs.length - 1) : '';
    }
  }
};
</script>
<style scoped lang="scss">
// .el-upload--picture-card 控制加号部分
::v-deep.hide .el-upload--picture-card {
    display: none;
}
// 去掉动画效果
::v-deep .el-list-enter-active,
::v-deep .el-list-leave-active {
    transition: all 0s;
}

::v-deep .el-list-enter, .el-list-leave-active {
  opacity: 0;
  transform: translateY(0);
}
</style>

